#include "Wire.h"
#define rtc_address 0x6F 

byte number = 0;

void setup() {
  Wire.begin();
  Serial.begin(9600); 
}


void loop() {
  delay(1000);

  Wire.beginTransmission(rtc_address);
  Wire.write(0x00);
  Wire.endTransmission();
  Wire.requestFrom(rtc_address,7);

  byte seconds = 0xFF;
  byte minutes = 0xFF;
  byte hours = 0xFF;
  byte day = 0xFF;
  byte date = 0xFF;
  byte month = 0xFF;
  byte year = 0xFF;
  
  if (Wire.available()) {
    seconds = (Wire.read() & 0x7F);
    minutes = (Wire.read() & 0x7F);
    hours = (Wire.read() & 0x1F);
    day = (Wire.read() & 0x07);
    date = (Wire.read() & 0x07);
    month = (Wire.read() & 0x07);
    year = (Wire.read() & 0x07);
  }

  //Serial.println(rdata);
  Serial.print("Year = ");
  Serial.print(year);
  Serial.print(" Month = ");
  Serial.print(month);
  Serial.print(" Date = ");
  Serial.print(date);
  Serial.print(" Day = ");
  Serial.print(day);
  Serial.print(" Hours = ");
  Serial.print(hours);
  Serial.print(" Minutes = ");
  Serial.print(minutes);
  Serial.print(" Seconds = ");
  Serial.print(seconds);
  Serial.println();

  if (Serial.available() >= 1) {
    char c = Serial.read();
    if (c == 'o') { // Set MFP
      Wire.beginTransmission(rtc_address);
      Wire.write(0x07);
      //Wire.write(0x40); // 1hz
      //Wire.write(0x43); // 32khz no trim
      //Wire.write(0x44); // 64hz
      //Wire.write(0x45); // 8khz
      Wire.endTransmission();

      Serial.println("OK");
    }

    if (c == 'i') { // Increase trim
      number++;

      Wire.beginTransmission(rtc_address);
      Wire.write(0x08);
      Wire.write(number);
      Wire.endTransmission();

      Serial.print("Increased to");
      Serial.println(number);
    }
    if (c == 'd') { // Decrease trim
      number--;

      Wire.beginTransmission(rtc_address);
      Wire.write(0x08);
      Wire.write(number);
      Wire.endTransmission();

      Serial.print("Decreased to");
      Serial.println(number);
    }
    if (c == 'm') { // Set/De-set the 7th bit
      if (number == 0) {
        number = 128;
      }
      else {
        number = 0;
      }
    }

    if (c == 's') { // Start the RTC
      Wire.beginTransmission(rtc_address);
      Wire.write(0x00);
      Wire.write(0x80); 
      Wire.endTransmission();
    }

    if (c == 'r') { // Read out the trim
      Wire.beginTransmission(rtc_address);
      Wire.write(0x08);
      Wire.endTransmission();
      Wire.requestFrom(rtc_address,1);
      
      Serial.print("Cal = ");
      Serial.println(Wire.read());
    }
  }
}
